#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bintree.h"

BinTree* createExampleBinTree();
void preorderTraversalRecursiveBinTree(BinTree *pBinTree);
void inorderTraversalRecursiveBinTree(BinTree *pBinTree);
void postorderTraversalRecursiveBinTree(BinTree *pBinTree);

int main(int argc, char *argv[])
{
	BinTree *pBinTree = createExampleBinTree();
	if (pBinTree != NULL) {
		printf(" ȸ : ");
		preorderTraversalRecursiveBinTree(pBinTree);
		printf(" ȸ : ");
		inorderTraversalRecursiveBinTree(pBinTree);
		printf(" ȸ : ");
		postorderTraversalRecursiveBinTree(pBinTree);

		deleteBinTree(pBinTree);
	}

	return 0;
}

BinTree* createExampleBinTree()
{
	BinTree* pReturn = NULL;
	BinTreeNode *pNodeA = NULL, *pNodeB = NULL, *pNodeC = NULL;

	pReturn = makeBinTree('A');
	if (pReturn != NULL) {
		pNodeA = getRootNodeBT(pReturn);
		pNodeB = addLeftChildNodeBT(pNodeA, 'B');
		pNodeC = addRightChildNodeBT(pNodeA, 'C');
		if (pNodeB != NULL) {
			addLeftChildNodeBT(pNodeB, 'D');
			addRightChildNodeBT(pNodeB, 'E');
		}
		if (pNodeC != NULL) {
			addLeftChildNodeBT(pNodeC, 'F');
			addRightChildNodeBT(pNodeC, 'G');
		}
	}

	return pReturn;
}


void preorderTraversalRecursiveBinTreeNode(BinTreeNode *pNode)
{
	if (pNode != NULL) {
		printf("%c ", pNode->data);
		preorderTraversalRecursiveBinTreeNode(pNode->pLeftChild);
		preorderTraversalRecursiveBinTreeNode(pNode->pRightChild);
	}
}

void preorderTraversalRecursiveBinTree(BinTree *pBinTree)
{
	if (pBinTree != NULL) {
		preorderTraversalRecursiveBinTreeNode(pBinTree->pRootNode);
		printf("\n");
	}
}

void inorderTraversalRecursiveBinTreeNode(BinTreeNode *pNode)
{
	if (pNode != NULL) {
		inorderTraversalRecursiveBinTreeNode(pNode->pLeftChild);
		printf("%c ", pNode->data);
		inorderTraversalRecursiveBinTreeNode(pNode->pRightChild);
	}
}

void inorderTraversalRecursiveBinTree(BinTree *pBinTree)
{
	if (pBinTree != NULL) {
		inorderTraversalRecursiveBinTreeNode(pBinTree->pRootNode);
		printf("\n");
	}
}

void postorderTraversalRecursiveBinTreeNode(BinTreeNode *pNode)
{
	if (pNode != NULL) {
		postorderTraversalRecursiveBinTreeNode(pNode->pLeftChild);
		postorderTraversalRecursiveBinTreeNode(pNode->pRightChild);
		printf("%c ", pNode->data);

	}
}

void postorderTraversalRecursiveBinTree(BinTree *pBinTree)
{
	if (pBinTree != NULL) {
		postorderTraversalRecursiveBinTreeNode(pBinTree->pRootNode);
		printf("\n");
	}

}
